/*
 * Copyright (c) 2009, 2020 Oracle and/or its affiliates. All rights reserved.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0, which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the
 * Eclipse Public License v. 2.0 are satisfied: GNU General Public License,
 * version 2 with the GNU Classpath Exception, which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 */

/*
 * $Id$
 */
package com.sun.ts.tests.jsf.api.jakarta_faces.factoryfinder.altfacesconfig;

import java.io.IOException;
import java.io.PrintWriter;

import com.sun.ts.tests.jsf.common.servlets.FactoryTCKServlet;

import jakarta.faces.FactoryFinder;
import jakarta.faces.context.FacesContextFactory;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

public class TestServlet extends FactoryTCKServlet {

  public void getFactoryAltfacesConfigTest(HttpServletRequest request,
      HttpServletResponse response) throws ServletException, IOException {
    PrintWriter pw = response.getWriter();

    String factory = "com.sun.ts.tests.jsf.common.factories."
        + "TCKContextFactory";
    try {

      FacesContextFactory fcf = (FacesContextFactory) FactoryFinder
          .getFactory(FactoryFinder.FACES_CONTEXT_FACTORY);

      String factName = fcf.getWrapped().getClass().getCanonicalName();

      if (factName.contains("TCKContextFactory")) {
        pw.println("FacesContextFactory Being Used: " + factName);
        pw.println("Test PASSED");
      } else {
        pw.println("Wrong FacesContextFactory Being Used");
        pw.println("Found: " + FactoryFinder
            .getFactory(FactoryFinder.FACES_CONTEXT_FACTORY).toString());
        pw.println("Expected: " + factory);
        pw.println("Test FAILED.");
      }

    } catch (Exception e) {
      pw.println("Test FAILED.");
      pw.println(e.toString());
    }
  }
}
